from typing import Any, Dict, List, Type, TypeVar

import attr

T = TypeVar("T", bound="ChangeOwnerJsonBody")


@attr.s(auto_attribs=True)
class ChangeOwnerJsonBody:
    """
    Attributes:
        owner_id (str): The user ID of the new owner. Example: hx7fqtqxp7nn8129t7e505ls6s.
    """

    owner_id: str
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        owner_id = self.owner_id

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "owner_id": owner_id,
            }
        )

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        owner_id = d.pop("owner_id")

        change_owner_json_body = cls(
            owner_id=owner_id,
        )

        change_owner_json_body.additional_properties = d
        return change_owner_json_body

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
