from typing import Any, Dict, List, Type, TypeVar, Union

import attr

from ..types import UNSET, Unset

T = TypeVar("T", bound="LicenseRenewalLink")


@attr.s(auto_attribs=True)
class LicenseRenewalLink:
    """
    Attributes:
        renewal_link (Union[Unset, str]): License renewal link
    """

    renewal_link: Union[Unset, str] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        renewal_link = self.renewal_link

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if renewal_link is not UNSET:
            field_dict["renewal_link"] = renewal_link

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        renewal_link = d.pop("renewal_link", UNSET)

        license_renewal_link = cls(
            renewal_link=renewal_link,
        )

        license_renewal_link.additional_properties = d
        return license_renewal_link

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
