from typing import Any, Dict, List, Type, TypeVar

import attr

T = TypeVar("T", bound="SetPostReminderJsonBody")


@attr.s(auto_attribs=True)
class SetPostReminderJsonBody:
    """
    Attributes:
        target_time (int): Target time for the reminder
    """

    target_time: int
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        target_time = self.target_time

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "target_time": target_time,
            }
        )

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        target_time = d.pop("target_time")

        set_post_reminder_json_body = cls(
            target_time=target_time,
        )

        set_post_reminder_json_body.additional_properties = d
        return set_post_reminder_json_body

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
