from typing import Any, Dict, List, Type, TypeVar

import attr

T = TypeVar("T", bound="TestSiteURLJsonBody")


@attr.s(auto_attribs=True)
class TestSiteURLJsonBody:
    """
    Attributes:
        site_url (str): The Site URL to test
    """

    site_url: str
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        site_url = self.site_url

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "site_url": site_url,
            }
        )

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        site_url = d.pop("site_url")

        test_site_url_json_body = cls(
            site_url=site_url,
        )

        test_site_url_json_body.additional_properties = d
        return test_site_url_json_body

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
